class Object
  #クラスにモジュール module_to_include のメソッド *method_names を追加する
  def add_methods(module_to_include, *method_names)
    method_names.each do |m|
      pr = module_to_include.method(m).to_proc
      define_method(m, &pr)
    end
  end
end

class Module
  #モジュール内のすべてのメソッドをクラスメソッドにする
  def register_all_methods
    instance_methods.each do |m|
      module_function m
    end
  end
end
