class Rational
  #分数を循環小数に直す
  # @return [String]
  def to_rec_decimal
    f, num = (self < 0) ? ["-", -self] : ["", self]
    
    i = num.to_i
    result = f + i.to_s
    ra = num - i
    return result if ra.zero?
    result += "."
    
    remainder = ra.numerator
    deno      = ra.denominator
    place = []
    rems = []
    begin
      rems  << remainder
      place << remainder * 10 / deno
      remainder = remainder * 10 % deno
      return result + place.join if remainder.zero?
    end while not (idx = rems.find_index(remainder))
    place.insert(idx, "(")
    result + place.join + ")"
  end
end

class String
  alias :__to_r__ :to_r
  #循環小数を分数に直す
  # @return [Rational]
  def to_r
    st = delete(" ")
    return st.__to_r__ unless (m = /^([^\d]?)(\d+)\.(\d*)\((\d+)\)$/.match(st))
    f = (m[1] == "-") ? -1 : 1
    
    result = (m[2] + "." + m[3]).__to_r__
    l = m[4].length
    result += Rational(m[4].to_i, 10 ** l - 1) * Rational(1, 10) ** m[3].length
    result * f
  end
end

